;!!!!!!!!!!!!   IF YOU RENAME THIS FILE THEN DO NOT FORGET !!!!!!!!!!!!!
;!!!!!!!!!!!!   TO CHANGE EVERY OCCURRENCE OF KBHANDL_TEXT IN !!!!!!!!!!!!!!!
;!!!!!!!!!!!!   THIS FILE TO MATCH THE NEW FILE NAME     !!!!!!!!!!!!!!!

;DON'T FORGET THAT THIS FILE HAS TO BE ASSEMBLED CASE-SENSITIVE
;(COMMAND LINE SWITCH /MX) !!!

; written 15/7/1998 by Matthias Benkmann
;(Matthias.Benkmann@Physik.uni-muenchen.de)

;feel free to copy this code

.286p
DGROUP	group	_DATA

_DATA	segment word public 'DATA'

public _KeyMap
public _Int9PassThrough
_KeyMap db 256 dup (0)
_Int9PassThrough dw 1
_DATA	ENDS

KBHANDL_TEXT segment byte public 'CODE'
	assume	cs:KBHANDL_TEXT, ds:DGROUP

public _InstallKeyboardHandler
_InstallKeyboardHandler proc far
                 push bp
                 mov bp,sp

                 cmp cs:[NewKeyboardIntInstalled],2
                 jne @@skip
                 mov es,ss:[bp+6]
                 mov ax,es:[10]
                 mov cs:[oldexit],ax
                 mov ax,es:[12]
                 mov cs:[oldexit+2],ax
                 mov cs:[exitpspaddr],es
                 mov word ptr es:[10],offset exitproc
                 mov word ptr es:[12],cs
@@skip:

                 mov ax,3509h
                 int 21h         ;get old keyboard int
                 mov cs:[oldint9+2],es
                 mov cs:[oldint9],bx

                 push ds
                 push cs
                 pop ds
                 mov dx,offset NewInt9
                 mov ax,2509h      ;set new interrupt handler for keyboard
                 int 21h
                 pop ds

                 mov cs:[NewKeyboardIntInstalled],1

                 pop bp

	         ret
NewKeyboardIntInstalled db 2 ; 2 means that exitproc not yet installed
_InstallKeyboardHandler endp

public _DeinstallKeyboardHandler
_DeinstallKeyboardHandler proc far
                          ;SHOULD PUSH REGS, MAY BE CALLED BY EXITPROC
                 cmp cs:[NewKeyboardIntInstalled],1
                 jne @@skipx

                 push dx
                 push ax
                 push ds

                 mov ds,cs:[oldint9+2]
                 mov dx,cs:[oldint9]
                 mov ax,2509h      ;restore old handler for keyboard
                 int 21h

                 mov cs:[NewKeyboardIntInstalled],0

                 pop ds
                 pop ax
                 pop dx
@@skipx:
	         ret
_DeinstallKeyboardHandler endp

NewInt9               proc far
                      push ax
                      push bx
                      push ds

                      mov ax,_DATA
                      mov ds,ax

                      xor ax,ax
                      in al,60h

                      mov bl,cs:[e0found]
                      mov cs:[e0found],0

                      cmp al,0e0h
                      je @@e0

                      shl ax,1   
                      shr al,1
                      xor ah,1   ;ah=0 if al>127

                      add bl,al
                      xor bh,bh

                      mov [_KeyMap][bx],ah

@@exit:
                      cmp [_Int9PassThrough],0
                      je @@nopass

                      pop ds
                      pop bx
                      pop ax
                      db 0eah        ;pass call to original handler
oldint9               dw 0
                      dw 0
@@nopass:
                      mov al,20h
                      out 20h,al  ;send EOI
                      pop ds
                      pop bx
                      pop ax
                      iret

@@e0:
                      mov cs:[e0found],128
                      jmp @@exit


e0found db 0
NewInt9               endp

exitproc proc far
         call _DeinstallKeyboardHandler
         push ds
         push ax

         xor ax,ax
         mov ds,ax
         mov ax,cs:[oldexit]
         mov ds:[22h*4],ax
         mov ax,cs:[oldexit+2]
         mov ds:[22h*4+2],ax
         mov ds,cs:[exitpspaddr]
         mov ds:[12],ax
         mov ax,cs:[oldexit]
         mov ds:[10],ax

         pop ax
         pop ds
         db 0eah
oldexit  dw 0
         dw 0
exitpspaddr dw 0
exitproc endp


KBHANDL_TEXT	ENDS
END
